/****************************************************************************************
 * Default facade-pixels manager, to be extended by your own class
 * 
 * No need to change this!
 ****************************************************************************************/


class Facade
{

    color[] grid;//array of colours, one per spot/window
    int nbSpots;


    Facade(int n)
    {
        nbSpots = n;
        grid = new color[nbSpots];//one per spot/window

        //setting up DMX stuff
        setupDMX(dmxIP);
    }

    //default updater : random
    void update()
    {
        for (int i = grid.length-1;i>=0;i--) {
            grid[i]= color(random(255), random(255), random(255));
        }
    }

    //draw the grid on screen
    void scrDraw()
    {
        colorMode(HSB);
        for (int i = grid.length-1;i>=0;i--) {
            fill(grid[i]);
            rect(20+i*80, 200, 50, 50);
        }
    }

    //send the grid to dmx
    void dmxDraw()
    {
        int [] buffer = new int[nbSpots*3]; //dmx data to be sent. Size = nb spots * 3 channels/colours
        int j=0;
        color c;
        colorMode(RGB);
        for (int i = 0; i < grid.length; i++) {
            c=grid[i];
            buffer[j]=(int)red(c); 
            j++; 
            buffer[j]=(int)green(c); 
            j++; 
            buffer[j]=(int)blue(c); 
            j++;
        }

        dmxUdpSender.resend(buffer);
        // println(buffer);
    }

    void click() {
    }
}

