import java.util.Collections;

class SmileFacade extends Facade
{

    boolean smiled;
    
    int randomColor; // used for patterns
    int randomSmileColor;
    float fadePercent;
    
    color currentColor;
    
    color[] patternColors;
    float patternFadePercent;
    int gradientOffset;
    
    PApplet papplet;
    
    int currentMode;
    int prevMode;
    
    ArrayList<Integer> randomNumbers;
    
    SmileFacade( PApplet _papplet, int n )
    {
        super( n );
        papplet = _papplet;
        
        smiled = false;
        
        fadePercent = 0.0f;
        patternFadePercent = 0.0f;
        
        currentColor = color( 255 );
                
        randomColor = floor( random( MAX_SWATCHES ) );
        randomSmileColor = floor( random( 3 ) );
                
        randomNumbers = new ArrayList<Integer>();
        for ( int i = 0; i < n; i++ ) {
            randomNumbers.add( i );
        }
        
        Collections.shuffle( randomNumbers );
        
        println( randomNumbers );
        patternColors = new color[ n ];
        println( "Patterncolors Length: " + patternColors.length );
        fillPatternColors();
        
        prevMode = 0;
        currentMode = 0;
        
        gradientOffset = 0;
        
    }
    
    void update()
    {
                
        if ( smiled ) {
                
            patternFadePercent = 0.0;

            currentColor = lerpColor( smileColors.getColor( randomSmileColor ), color( 0 ), fadePercent );
            fadePercent += 0.005;

            grid[ 0 ] = currentColor;
            grid[ 5 ] = currentColor;
            grid[ 6 ] = currentColor;
            grid[ 7 ] = currentColor;
            grid[ 10 ] = currentColor;
            grid[ 11 ] = currentColor;
            grid[ 13 ] = currentColor;
            grid[ 14 ] = currentColor;
            grid[ 15 ] = currentColor;
            grid[ 16 ] = currentColor;

            grid[ 1 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 2 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 3 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 4 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 8 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 9 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 12 ] =  color( 0 ); //lerpColor( currentColor, color( 0 ), 0.75 );
            grid[ 17 ] =  lerpColor( currentColor, color( 0 ), 0.75 );
                
        } else {
            // not smiling. Create a pattern and draw it to the screen
            fadePercent = 0.0;
            patternFadePercent += 0.004;
            for ( int i = 0; i < grid.length; i++ ) {
                grid[ i ] =  lerpColor( patternColors[i], color( 0 ), patternFadePercent );
            }
        }
        
        if ( fadePercent >= 1 ) {
            fadePercent = 0.0;
            smiled = false;
            randomColor = floor( random( MAX_SWATCHES ) );
        }
        
        if ( patternFadePercent >= 1 ) {
            patternFadePercent = 0.0;
            fillPatternColors();
            gradientOffset += 1;
            if ( gradientOffset >= 3 ) {
                gradientOffset = 0;
            }
        }
    }
    
    void scrDraw()
    {
        int counter = 0;
        
        stroke( 255, 64 );
        
        pushMatrix();
        translate( 75, 75 );
        for ( int i = 0; i < 6; i++ ) {
            fill( grid[ counter ] );
            rect( i * 150, 0, 100, 100 );
            counter++;
        }
        translate( 0, 150 );
        for ( int i = 0; i < 6; i++ ) {
            fill( grid[ counter ] );
            rect( i * 150, 0, 100, 100 );
            counter++;
        }
        translate( 0, 150 );
        for ( int i = 0; i < 6; i++ ) {
            fill( grid[ counter ] );
            rect( i * 150, 0, 100, 100 );
            counter++;
        }
        popMatrix();
    }

    void fillPatternColors()
    {
        boolean gradientMode = false;
        if ( random( 100 ) < 50 ) {
            gradientMode = true;
        }

        color[] grc = new color[2];
        grc[0] = p.getColor( floor( random( MAX_SWATCHES ) ) );
        grc[1] = p.getColor( floor( random( MAX_SWATCHES ) ) );
        Gradient gr = new Gradient( papplet, grc, 6 );
        
        if ( gradientMode ) {
            for ( int i = 0; i < patternColors.length; i++ ) {
                patternColors[i] = color( 0 );       
            }
            for ( int i = 0; i < 6; i++ ) {
                patternColors[ i + ( gradientOffset * 6 )] = gr.getColor( i );
            }
    
        } else {
            
            Collections.shuffle( randomNumbers );
            
            for ( int i = 0; i < patternColors.length; i++ ) {
                patternColors[i] = color( 0 );       
            }
            
            for ( int i = 0; i < 6; i++ ) {
                int n = randomNumbers.get( i );
                patternColors[ (int)randomNumbers.get(i) ] = gr.getColor( i );
            }
            println("---");
        
        }

    }
    
    void modeChanged()
    {
        prevMode = currentMode;
        
        boolean changed = false;
        if ( smiled ) {
            currentMode = 1;
        } else {
            currentMode = 0;    
        }
        
        if ( currentMode != prevMode ) {
            changed = true;
        }
        
        if ( changed ) {
            patternFadePercent = 0.0;
            fillPatternColors();
            fadePercent = 0.0;
            randomColor = floor( random( MAX_SWATCHES ) );
            randomSmileColor = floor( random( 3 ) );
        }
       
    }

}
