import colorLib.calculation.*;
import colorLib.*;
import colorLib.webServices.*;

import oscP5.*;
import netP5.*;

OscP5 osc;

SmileFacade facade;

Palette p;
PImage colorImage;
int MAX_SWATCHES;
Palette smileColors;

String dmxIP = "192.168.1.77";
int nbSpots = 18;

void setup()
{
    size( 1050, 600 );

    colorImage = loadImage( "smilecolors.png" );
    p = new Palette( this, colorImage );
    MAX_SWATCHES =  p.totalSwatches();

    facade = new SmileFacade( this, nbSpots );
        
    osc = new OscP5( this, 12345 );
    
    smileColors = new Palette( this );
    smileColors.addColor( color( 255, 37, 29 ) );
    smileColors.addColor( color( 217, 28, 88 ) );
    smileColors.addColor( color( 255, 0, 0 ) );
    
    frameRate( 25 );
}

void draw()
{
    background( 0 );
    facade.update();
    facade.scrDraw();
    facade.dmxDraw();
}

void oscEvent( OscMessage msg )
{
    
    if ( msg.checkAddrPattern("/smile") == true ) {
        if ( msg.checkTypetag("i") ) {
            int smiled = msg.get(0).intValue();
            if ( smiled == 1 ) {
                facade.smiled = true;
            } else {
                facade.smiled = false;
            }
            facade.modeChanged();
        } 
    }
}
